// The xMule Project - A Peer-2-Peer File Sharing Program
//
// Copyright (C) 2003-2006 Theodore R. Smith ( hopeseekr@gmail.com / http://www.xmule.ws/ )
// Copyright (C) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of Version 2 of the GNU General Public
// License as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

#ifdef PRECOMP
    #include "xmule-headers.h"
#endif

#include "CommentDialog.h"        // Interface's Prototype

#include "KnownFile.h"            // CKnownFile
#include "otherfunctions.h"       // GetResString
#include "xmule.h"                // GetColor

#include <wx/combobox.h>          // wxComboBox
#include <wx/panel.h>             // wxPanel
#include <wx/textctrl.h>          // wxTextCtrl
#include <wx/xrc/xmlres.h>        // wxXmlResource

#define GetDlgItem(x,clas) XRCCTRL(*this,#x,clas)

BEGIN_EVENT_TABLE(CCommentDialog, wxDialog)
    EVT_BUTTON(wxID_OK, CCommentDialog::OnBnClickedApply)
END_EVENT_TABLE()

CCommentDialog::CCommentDialog(wxWindow *parent, CKnownFile *file):
    wxDialog(parent, -1, _("File Comments"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE |wxSYSTEM_MENU)
{
    m_file = file;
    wxXmlResource::Get()->LoadDialog(this, parent, wxT("DLG_COMMENT"));
    Center();
    ratebox = GetDlgItem(IDC_RATELIST, wxComboBox);
    OnInitDialog();
}

CCommentDialog::~CCommentDialog()
{
}

void CCommentDialog::OnBnClickedApply(wxCommandEvent &evt)
{
    wxString SValue;
    SValue = GetDlgItem(IDC_CMT_TEXT, wxTextCtrl)->GetValue();
    m_file->SetFileComment(wxString(SValue));
    m_file->SetFileRate((int8_t) ratebox->GetSelection());
    EndModal(0);
}

bool CCommentDialog::OnInitDialog()
{
    Localize();
    GetDlgItem(IDC_CMT_TEXT, wxTextCtrl)->SetValue(m_file->GetFileComment());
    GetDlgItem(IDC_CMT_TEXT, wxTextCtrl)->SetMaxLength(50);
    return true;
}

void CCommentDialog::Localize()
{
    while (ratebox->GetCount() > 0)
    {
        ratebox->Delete(0);
    }

    ratebox->Append(GetResString(IDS_CMT_NOTRATED));
    ratebox->Append(GetResString(IDS_CMT_FAKE));
    ratebox->Append(GetResString(IDS_CMT_POOR));
    ratebox->Append(GetResString(IDS_CMT_GOOD));
    ratebox->Append(GetResString(IDS_CMT_FAIR));
    ratebox->Append(GetResString(IDS_CMT_EXCELLENT));
    ratebox->SetSelection(m_file->GetFileRate());

    wxString strTitle;
    strTitle.Printf(GetResString(IDS_CMT_TITLE), wxString(m_file->GetFileName(), *wxConvCurrent).GetData());
    SetTitle(strTitle);
}
